/*
 *  PoolMan Java Object Pooling and Caching Library
 *  Copyright (C) 1999-2001 The Code Studio
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  The full license is located at the root of this distribution
 *  in the LICENSE file.
 */
package com.codestudio.bean.struts;

import org.apache.struts.action.ActionForm;
import org.apache.struts.upload.FormFile;

import java.util.ArrayList;
import java.util.Enumeration;

import com.codestudio.util.SQLManager;

public class PoolManActionFormBean
        extends ActionForm {

    protected String sql;
    protected String currentDatabaseName;
    protected ArrayList allDatabaseNames;

    public String getSql() {
        return sql;
    }

    public void setSql(String sql) {
        this.sql = sql;
    }

    public String getCurrentDatabaseName() {
        return currentDatabaseName;
    }

    public void setCurrentDatabaseName(String currentDatabaseName) {
        this.currentDatabaseName = currentDatabaseName;
    }

    public ArrayList getAllDatabaseNames() {
        if ((allDatabaseNames == null) || (allDatabaseNames.size() < 1)) {
            allDatabaseNames = new ArrayList();
            Enumeration enum = SQLManager.getInstance().getAllPoolnames();
            while (enum.hasMoreElements()) {
                allDatabaseNames.add(enum.nextElement());
            }
            if (allDatabaseNames.size() < 1)
                allDatabaseNames = null;
        }
        return allDatabaseNames;
    }

}

