/*
 *  PoolMan Java Object Pooling and Caching Library
 *  Copyright (C) 1999-2001 The Code Studio
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  The full license is located at the root of this distribution
 *  in the LICENSE file.
 */
package com.codestudio.management;


public interface DataSourceServiceMBean extends ObjectPoolServiceMBean {

    /* PHYSICAL CONNECTION METHODS */

    public String getDriver();

    public void setDriver(String driver);

    public String getURL();

    public void setURL(String URL);

    public String getUserName();

    public void setUserName(String username);

    public String getPassword();

    public void setPassword(String password);

    public String getDbname();

    public void setDbname(String dbname);

    public String getJNDIName();

    public void setJNDIName(String dbname);

    public boolean isNativeResults();

    public void setNativeResults(boolean b);

    /* POOL BEHAVIOR METHODS */

    public boolean isPoolPreparedStatements();

    public void setPoolPreparedStatements(boolean poolingPreparedStatements);

    public String getValidationQuery();

    public void setValidationQuery(String sql);

    public int getInitialConnections();

    public void setInitialConnections(int n);

    public int getConnectionTimeout();

    public void setConnectionTimeout(int n);

    public String getInitialPoolSQL();

    public void setInitialPoolSQL(String sql);

    public String getInitialConnectionSQL();

    public void setInitialConnectionSQL(String sql);

    public boolean isRemoveOnExceptions();

    public void setRemoveOnExceptions(boolean b);

    /* TX METHODS */

    public int getTransactionTimeout();

    public void setTransactionTimeout(int n);

    public String getTxIsolationLevel();

    public void setTxIsolationLevel(String s);

    /* QUERY CACHE METHODS */

    public boolean isCacheEnabled();

    public void setCacheEnabled(boolean b);

    public int getCacheSize();

    public void setCacheSize(int n);

    public int getCacheRefreshInterval();

    public void setCacheRefreshInterval(int seconds);

    /* READ-ONLY MONITORING METHODS */

    public int getAvailableConnections();

    public int getUnavailableConnections();

    public int getTotalConnections();


}


