/*
 *  PoolMan Java Object Pooling and Caching Library
 *  Copyright (C) 1999-2001 The Code Studio
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  The full license is located at the root of this distribution
 *  in the LICENSE file.
 */
package com.codestudio.management;

import java.io.Serializable;

public interface ObjectPoolServiceMBean extends Serializable {

    /* ACTION METHODS */

    public void start() throws Exception;

    public void stop() throws Exception;

    /* POOL ID METHODS */

    public String getName();

    public void setName(String name);

    /* POOL PROPERTY METHODS */

    public int getInitialObjects();

    public void setInitialObjects(int n);

    public int getMinimumSize();

    public void setMinimumSize(int n);

    public int getMaximumSize();

    public void setMaximumSize(int n);

    public int getObjectTimeout();

    public void setObjectTimeout(int n);

    public int getUserTimeout();

    public void setUserTimeout(int n);

    public int getSkimmerFrequency();

    public void setSkimmerFrequency(int n);

    public int getShrinkBy();

    public void setShrinkBy(int n);

    public boolean isMaximumSoft();

    public void setMaximumSoft(boolean b);

    /* POOL AUDIT METHODS */

    public String getLogFile();

    public void setLogFile(String filename);

    public boolean isDebugging();

    public void setDebugging(boolean b);

}



