/*
 *  PoolMan Java Object Pooling and Caching Library
 *  Copyright (C) 1999-2001 The Code Studio
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  The full license is located at the root of this distribution
 *  in the LICENSE file.
 */
package com.codestudio.sql;

import java.io.Serializable;

/**
 * A helper class that indexes a particular element in a
 * ResultSet row. A list contains entries for each row.
 * Each of these entries, or rows, is also a list that holds
 * ordered Result objects.
 */
public class Result implements Serializable {

    public final String tableName;
    public final String colName;
    public final Object colValue;
    public final int type;

    public Result(final String tableName, final String colName, final Object colValue, final int type) {

        this.tableName = tableName;
        this.colName = colName;
        this.colValue = colValue;
        this.type = type;

    }

    public String toString() {
        return new String("com.codestudio.sql.Result: " + " table=" + tableName + " column=" + colName + " value=" + colValue + " type=" + type);
    }
}
