package poolman.tests.basic;

import com.codestudio.util.ObjectPool;
import com.codestudio.util.SQLManager;
import com.codestudio.util.JDBCPool;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import java.sql.Connection;
import java.sql.Statement;

public class MultiplePoolTests extends TestCase {

    public MultiplePoolTests(String name) {
        super(name);
    }

    public static Test suite() {
        return new TestSuite(MultiplePoolTests.class);
    }

    public void testTwoPools() {

        try {

            // get first test pool
            ObjectPool pool1 = SQLManager.getInstance().getPool("testdb");
            String poolName1 = pool1.getPoolname();

            // get second test pool
            ObjectPool pool2 = SQLManager.getInstance().getPool("testdb2");
            String poolName2 = pool2.getPoolname();

            assertEquals(poolName1, "testdb");
            assertEquals(poolName2, "testdb2");

        } catch (Exception e) {
            e.printStackTrace();
            fail();
        }
    }

    public void testDefaultPool() {

        try {

            // get default pool
            ObjectPool defaultPool = SQLManager.getInstance().getPool(null);
            String defaultName = defaultPool.getPoolname();

            // get first test pool
            ObjectPool pool1 = SQLManager.getInstance().getPool("testdb");
            String poolName1 = pool1.getPoolname();

            assertEquals(defaultName, poolName1);

        } catch (Exception e) {
            e.printStackTrace();
            fail();
        }
    }

       public void testTwoPoolsWithConnections() {

        try {

            // get first test pool
            ObjectPool pool1 = SQLManager.getInstance().getPool("testdb");
            String poolName1 = pool1.getPoolname();
            Connection con1 = ((JDBCPool) pool1).requestConnection();
            Statement s1 = con1.createStatement();
            s1.executeQuery("select * from neville");
            s1.close();
            con1.close();

            // get second test pool
            ObjectPool pool2 = SQLManager.getInstance().getPool("testdb2");
            String poolName2 = pool2.getPoolname();
            Connection con2 = ((JDBCPool) pool2).requestConnection();
            Statement s2 = con2.createStatement();
            s2.executeQuery("select * from users");
            s2.close();
            con2.close();

        } catch (Exception e) {
            e.printStackTrace();
            fail();
        }
    }
}
