package poolman.tests.util;

import junit.framework.*;
import poolman.tests.*;

import com.codestudio.util.*;
import java.sql.Connection;

/**
 * This suite of tests covers programmatically creating pools.
 */
public class
        ProgPoolTests extends TestCase {

    public ProgPoolTests(String name) {
	super(name);
    }

    public static Test suite() {
	return new TestSuite(ProgPoolTests.class);
    }

    public void testPoolCreation() {

	try {

	    JDBCPool jpool = (JDBCPool) SQLManager.getInstance().getPool("testdb");
	    
	    JDBCPoolMetaData meta = new JDBCPoolMetaData();
	    meta.setDriver(jpool.getDriver());
	    meta.setURL(jpool.getURL());
	    meta.setUserName(jpool.getUserName());
	    meta.setPassword(jpool.getPassword());
	    meta.setName("progtest");
	    meta.setJNDIName("progtest");
	    
	    JDBCPool newPool = new JDBCPool(meta);
	    SQLManager.getInstance().addPool("progtest", newPool);
	    
	    JDBCPool retPool = (JDBCPool) SQLManager.getInstance().getPool("progtest");
	    Connection con = retPool.requestConnection();
	    con.close();

	} catch (Exception e) {
	    e.printStackTrace();
	    fail();
	}
    }
}

