package poolman.tests.util;

import junit.framework.*;
import poolman.tests.*;
import java.util.*;
import com.codestudio.util.*;


/**
 * This suite of tests covers behavior of utility classes.
 */
public class UtilityTests extends TestCase {

    private String testKey = "1";
    private String testValue = "test";
    private Hashtable testHash;

    public UtilityTests(String name) {
	super(name);
    }

    public static Test suite() {
	return new TestSuite(UtilityTests.class);
    }

    protected void setUp() {
	this.testHash = new Hashtable(1);
	testHash.put(testKey, testValue);
    }
    
    public void testHashtableGet() {
	String s = (String) testHash.get(testKey);
	assertEquals(testValue, s);
    }

    public void testHashtablePut() {
	testHash.put("foo", "foobar");
	assert(testHash.containsKey("foo"));
    }
    
    public void testHashtableEquals() {
	Object value1 = new String(testValue);
	Object value2 = testHash.get(testKey);
	assertEquals(value1, value2); 
    }

    public void testHashtableToString() {
	String s = testHash.get(testKey).toString();
	assertEquals(testValue.toString(), s);
    }

    public void testHashtableIterator() {
	try {
	    Iterator iter = testHash.keySet().iterator();
	    while (iter.hasNext()) {
		Object key = iter.next().toString();
	    }
	} catch (Exception e) {
	    fail("Unable to iterate over test Hashtable: " +
		 e.getMessage());
	}
    }

    public void testHashtableEnumerator() {
	try {
	    for (Enumeration enum=testHash.keys(); enum.hasMoreElements(); ) {
		Object key = enum.nextElement();
		Object value = testHash.get(key);
	    }
	} catch (Exception e) {
	    fail("Unable to retrive an enumeration of Hashtable keys: " +
		 e.getMessage());
	}
    }
}

